/* Problem URL: https://codeforces.com/edu/course/2/lesson/4/1/practice/contest/273169/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vl fds(n);
    cin >> fds;

    while (__builtin_popcount(n) != 1) {
        n++;
        fds.push_back(INT64_MAX >> 1);
    }

    vl seg(n * 2);

    nrep(i, n, n * 2) {
        seg[i] = fds[i - n];
    }

    for (int i = n - 1; i > 0; i--) {
        seg[i] = min(seg[i * 2], seg[i * 2 + 1]);
    }

    function<void(int, ll)> update = [&](int i, ll v) {
        seg[i + n] = v;

        for (i = (i + n) >> 1; i > 0; i >>= 1) {
            seg[i] = min(seg[i * 2], seg[i * 2 + 1]);
        }
    };

    function<ll(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) -> ll {
        if (l > tr || r < tl) {
            return INT64_MAX >> 1;
        }

        if (l >= tl && r <= tr) {
            return seg[i];
        }

        int mid = (l + r) >> 1;

        return min(query(i * 2, l, mid, tl, tr), query(i * 2 + 1, mid + 1, r, tl, tr));
    };

    while (m--) {
        int op;
        cin >> op;
        if (op == 1) {
            int i;
            ll v;
            cin >> i >> v;

            update(i, v);
            continue;
        }

        int l, r;
        cin >> l >> r;

        cout << query(1, 0, n - 1, l, r - 1) << '\n';
    }

}
